import numpy as np


from sqlalchemy.ext.declarative import declarative_base
from sqlalchemy import create_engine
from sqlalchemy_utils import database_exists, create_database
from sqlalchemy import Table, Column, Integer, String, MetaData

user_id = "root"
user_password = "hegaole945"
dbname = "Analogy"

# Create engine through sqlalchemy
# engine = create_engine("mysql+pymysql://%s:%s@localhost:3306/%s" %(user_id,user_password,dbname),echo=False)
engine = create_engine("mysql+pymysql://%s:%s@localhost:3306/%s" %(user_id,user_password,dbname),echo=False)

# Create database if not exists
if not database_exists(engine.url): 
    create_database(engine.url)


from flaskr.db import *
import csv

def export_usertask():
    DBSession = sessionmaker(bind=engine)
    session = DBSession()

    q = session.query(UserTask)

    file = './usertask.csv'

    with open(file, 'w') as csvfile:
        outcsv = csv.writer(csvfile, delimiter=',',quotechar='"', quoting = csv.QUOTE_MINIMAL)

        header = UserTask.__table__.columns.keys()

        outcsv.writerow(header)     

        for record in q.all():
            outcsv.writerow([getattr(record, c) for c in header ])
    session.close()

def export_userinfo():
    DBSession = sessionmaker(bind=engine)
    session = DBSession()

    q = session.query(UserInfo)

    file = './userinfo.csv'

    with open(file, 'w') as csvfile:
        outcsv = csv.writer(csvfile, delimiter=',',quotechar='"', quoting = csv.QUOTE_MINIMAL)

        header = UserInfo.__table__.columns.keys()

        outcsv.writerow(header)     

        for record in q.all():
            outcsv.writerow([getattr(record, c) for c in header ])
    session.close()

def export_preq():
    DBSession = sessionmaker(bind=engine)
    session = DBSession()

    q = session.query(PreQ)

    file = './pre_questionnaire.csv'

    with open(file, 'w') as csvfile:
        outcsv = csv.writer(csvfile, delimiter=',',quotechar='"', quoting = csv.QUOTE_MINIMAL)

        header = PreQ.__table__.columns.keys()

        outcsv.writerow(header)     

        for record in q.all():
            outcsv.writerow([getattr(record, c) for c in header ])
    session.close()

if __name__ == "__main__":
    export_usertask()
    export_userinfo()
    export_preq()

# cmd = 'SELECT * FROM usertask'
# from sqlalchemy.sql import text
# with engine.connect() as con:
#     table_name = 'usertask'
#     # outfile = open('{}.csv'.format(table_name), 'wb')
#     # outcsv = csv.writer(outfile)

#     result = con.execute('select * from {}'.format(table_name, table_name)).fetchall()
#     print(result)
#     print(type(result), type(result[0]))

#     # dump column titles (optional)
#     # outcsv.writerow(x[0] for x in cursor.description)
#     # dump rows
#     # outcsv.writerows(cursor.fetchall())

#     # outfile.close()